<?php

if (!function_exists('sql_table'))
{
	function sql_table($name) {
		return 'nucleus_' . $name;
	}
}
class NP_FileProperty extends NucleusPlugin
{

	
	function getName() { return 'FileProperty'; }
	function getAuthor() { return 's.Fujisaki'; }
	function getURL() { return 'http://fjsk.s39.xrea.com/'; }
	function getVersion() { return '1.1'; }
		
	function supportsFeature($what) { 
		switch($what){ 
			case 'SqlTablePrefix': 
			return 1; 
			default: 
			return 0; 
		} 
	}
	function getDescription() { 
		return 'The size of a media file and an icon are displayed.';
	} 
	
	function getEventList() { return array('PreItem'); }
	
	function install() {
		$this->createOption("usestyle", "Is the style of a file size display portion used at the time of NP_LinkCounter installation?", "yesno", "yes");
		$this->createOption("filesizestyle", "file size view style?", "text", "color:Silver;font-size:70%;text-decoration:none;");
		$this->createOption("fileicon", "Use Icon?", "yesno", "no");
		$this->createOption("fileicondir", "Icon Directory(in media directory)", "text", "icon/");
//		$this->createOption("autolink", "Is the automatic count function of NP_LinkCounter used?", "yesno", "no");
	}

	var $curItem;
	function event_PreItem($data) { 
		$this->curItem =  &$data["item"]; 
		$this->curItem->body = preg_replace_callback("#<\%media\((.*?)\)%\>#", array(&$this, 'FilePropertyback'), $this->curItem->body); 
		$this->curItem->more = preg_replace_callback("#<\%media\((.*?)\)%\>#", array(&$this, 'FilePropertyback'), $this->curItem->more); 
	}
	
// get file size
	function DownloadSize($file) {
		$size = filesize($file);
		$sizes = Array('byte', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB');
		$ext = $sizes[0];
		for ($i=1; (($i < count($sizes)) && ($size >= 1024)); $i++) {
			$size = $size / 1024;
			$ext = $sizes[$i];
		}
		return round($size, 1).$ext;
		}

	function iconfile($file) {
		global $CONF, $DIR_MEDIA; 
		$ext = strtolower(str_replace(".","",strrchr($file,".")));
		$iconset = $DIR_MEDIA.$this->getOption('fileicondir').$ext.".gif";
		if (file_exists($iconset)){
			$icon = $CONF['MediaURL'].$this->getOption('fileicondir').$ext.".gif";
			return "<img src=\"$icon\" alt=\"\">";
		}else{
			return "";
		}
	}

	function FilePropertyback($matches) { 
		global $CONF, $DIR_MEDIA; 
		$p  = requestVar('p');			//file name
		$id = requestVar('id');			//blogid
		if(eregi("/",$p)) $rp = $DIR_MEDIA.$p;	//shared area
		else $rp = $DIR_MEDIA.$id.'/'.$p;
		$fileEx = strrchr($p,".");		//get file extension
		$exp_matches = explode('|', $matches[1]);
		$filename = $exp_matches[0];
		$comment  = $exp_matches[1];
		$LCkeyword  = $exp_matches[2];
		$myblogid = $this->curItem->authorid;
		if(eregi("/",$filename)){
			$p  = $DIR_MEDIA.$filename;	//shared area
			$fileurl = $CONF['MediaURL'].$filename;
			if($comment=="") $comment = str_replace("/","",strrchr($filename,"/"));
		}else{
			$p  = $DIR_MEDIA.$myblogid.'/'.$filename;			//private area
			$fileurl  = $CONF['MediaURL'].$myblogid.'/'.$filename;
			if($comment=="") $comment = $filename;
		}
		$unitsize = $this->DownloadSize($p);
		if($this->getOption('fileicon') == "yes"){ 
			$comment = $this->iconfile($p) . $comment; 
		} 
		$sizestyle = $this->getOption('filesizestyle'); 
		if(!$this->checkPlugin('LinkCounter') || ($LCkeyword=="" && $this->getOtherPluginOption('flg_auto') == "no")) { 
			return "<a href=\"$fileurl\">$comment<span style=\"$sizestyle\">($unitsize)</span></a>"; 
		} 
		else {
			if($this->getOption('usestyle') == "yes"){ 
				$comment .= "<span style=\"".$sizestyle."\">(".$unitsize.")</span>"; 
			}else{
				$comment .= "(".$unitsize.")";
			}
			if($LCkeyword==""){ 
				return "<%media($filename|$comment)%>"; 
			}else{ 
				return "<%media($filename|$comment|$LCkeyword)%>"; 
			} 
		} 
	} 
	 
	function checkPlugin($pluginName) { 
		global $manager; 
		return $manager->pluginInstalled('NP_' . $pluginName); 
	} 
	
	function getOtherPluginOption($OptionName){
		$Opsql = "SELECT op_desc.oname,op.ovalue FROM ".sql_table('plugin_option_desc')." op_desc, ".sql_table('plugin_option')." op WHERE op_desc.oname = \"".$OptionName."\" AND op_desc.oid = op.oid";
		$result = mysql_query($Opsql);
		while($row=mysql_fetch_array($result)){
			return $row["ovalue"];
		}
	}

} 
?>

